Software center have hardcoded colors and shows white font on white bg

Bug #899878 reported by Alexander Kabakow on 2011-12-04
This bug affects 92 people
Affects Status Importance Assigned to Milestone
Ubuntu GNOME
Bruce Pieterse
Ubuntu Software Center
software-center (Ubuntu)

Bug Description

When using dark theme

ProblemType: Bug
DistroRelease: Ubuntu 11.10
Package: software-center 5.0.2ubuntu0.1
ProcVersionSignature: Ubuntu 3.0.0-13.22-generic 3.0.6
Uname: Linux 3.0.0-13-generic i686
ApportVersion: 1.23-0ubuntu4
Architecture: i386
Date: Sun Dec 4 15:28:41 2011
InstallationMedia: Ubuntu 10.10 "Maverick Meerkat" - Release i386 (20101007)
PackageArchitecture: all
 PATH=(custom, user)
SourcePackage: software-center
UpgradeStatus: Upgraded to oneiric on 2011-10-16 (48 days ago)

Related branches

Didier Roche: Approve on 2015-09-03
software-store-developers: Pending requested 2015-08-23
Alexander Kabakow (alexzak) wrote :
Launchpad Janitor (janitor) wrote :

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in software-center (Ubuntu):
status: New → Confirmed
Rob Hamm (drhamm) wrote :

I've been poking about, but there are a lot of files associated with the software center, so if one of you could tell me which of those to edit, I'll happy do it manually for now. I tried editing /usr/share/software-center/ui/gtk3/css/softwarecenter.css, but a;as, while I could change some colors there (specifically, the ones on the first screen), still couldn't change the colors for font or background for the application information screen.

Rob Hamm (drhamm) wrote :

(Sorry--I missed the obvious. Went back and changed the line @define-color super-light-aubergine #F4F1F3 to @define-color super-light-aubergine #6d6d6d; and it's working fine for now.)

joshg (joshg) wrote :

It's the same with freshly installed 12.04

Changed in software-center (Ubuntu):
importance: Undecided → Medium
Adolfo Jayme (fitojb) on 2013-10-19
Changed in software-center:
status: New → Confirmed
HEXcube (hexcube) wrote :

I can't believe that this bug started in Oneiric(maybe even before that) and it's still not fixed after Raring (as per ). Ubuntu Software Center is a core feature of Ubuntu distribution and yet such a bug which affects its usability is left unnoticed! Why can't it just follow the system theme instead of using hardcoded colors.
Some Dark Theme developers have found workarounds involving replacing the softwarecenter.css with custom versions. One such fix by Delorean Dark theme developer is attached here. It is optimised for Dark Themes and works fine with light ones too. I don't know if it works perfectly with light themes,but it does try to use current theme colors instead of hardcoded ones,atleast in some places.

HEXcube (hexcube) wrote :

I forgot to mention : i'm using Ubuntu 12.04 LTS with Ubuntu Software Center ver 5.2.9 . The fix is from hellokitten/killhelllokitty('s Delorean Dark 1.55 theme(PPA-

The attachment "Delorean Dark's Software Center fix for Dark Themes" seems to be a patch. If it isn't, please remove the "patch" flag from the attachment, remove the "patch" tag, and if you are a member of the ~ubuntu-reviewers, unsubscribe the team.

[This is an automated message performed by a Launchpad user owned by ~brian-murray, for any issues please contact him.]

tags: added: patch
tags: removed: patch
Matthew Paul Thomas (mpt) wrote :

(I reported the incorrect patch detection as bug 1246487.)

HEXcube, thank you for that research. I think the next steps towards getting this bug fixed are:

A. Replace USC's normal CSS file with killhellokitty's CSS file, to see if it works in both of the standard Ubuntu themes.
B. If it does work, produce a diff of one file against the other so we can see exactly what is changed.

HEXcube (hexcube) wrote :

I tried both default themes Radiance and Ambience in Ubuntu 12.04 to check if they work well with killhellokitty's CSS file. Everything seems to be okay, except for selected items' text color in list view. Both background and foreground are light colors. this is because the CSS file was designed for dark themes.
ideally software center should show dark text with light background and light text on dark themes. killhellokitty's css theme is better than the default one, but needs a little more work to be the ideal theme.

tags: added: saucy
Auroral Xylon (avlabs314) wrote :

Hi, I'm currently developing/designing a Gtk theme which sets a white background for GtkTreeView:selected. In the softwarecenter.css file, the background is hard coded to be selection_bg_color, meaning that the red (which is the selection bg color defined in my theme) text is invisible on the red selection background, as shown in the screenshot. Would it not be more reasonable to let the themer set the value for this?

Matthew Paul Thomas (mpt) wrote :

Auroral, what happens if that CSS rule is removed? Is the selected row still an appropriate color? If so, perhaps you could attach a patch that removes it. Thanks!

Tommy Miller (tommydrum) wrote :

To all you people who want a temporary fix.. This is what I did (look inside the file and first 2 lines..) I changed the colors of the background that way. It /kindof/ fixes it.. but at least you can read most things.. just not when the windows is off focus.

File is at /usr/share/software-center/ui/gtk3/css/softwarecenter.css

Ubuntu QA Website (ubuntuqa) wrote :

This bug has been reported on the Ubuntu ISO testing tracker.

A list of all reports related to this bug can be found here:

tags: added: iso-testing
Sam Hewitt (snwh) wrote :

A better solution would be to separate the CSS from the USC altogether and let themes dictate what the software centre looks like as the hardcoded nature of the CSS means other problems arise for theme developers.

Gabriel Couto (gmcouto) wrote :

Or maybe hardcode everything.
If you make an application with hardcoded BG color, your text over that background SHOULD use hardcoded font color.
App content should use just theme colors or should use just hardcoded colors... not both.
You can't mix things up.
That practice is not functional and result in a half-assed application.

Narcis Garcia (narcisgarcia) wrote :

Affects Ubuntu-Gnome 14.04

Solution A) All colors hardcodes
Solution B) All collors from environment theme

The mix is the problem.

Sam Hewitt (snwh) wrote :

If it was simply changes to the general case and those exact CSS classes we added to Ambiance/Radiance the issue would be solved & it would solve problems with several other themes.. Further hardcoding of the CSS worse.

leoheck (leoheck) wrote :

I have the same problem here.
Please, fix it.
And, HARDCODE is never an option.

tags: added: trusty

Also affects freshly installed 15.04 release candidate as of 26th of January.

Bruce Pieterse (octoquad) wrote :

Also present in Gnome 14.10 with staging ppa.

Changed in ubuntu-gnome:
importance: Undecided → Medium
status: New → Confirmed
tags: added: amd64 utopic
removed: oneiric saucy
Thayne (thayne-u) wrote :

Why is this still not fixed? it seems like it wouldn't be that hard, and it has been years since it was first reported.

Jakey_TheSnake (clampstand) wrote :

Does anybody here understand how we can/whether it's possible to get the theme colours into CSS? Sort of like "gtk:bg[NORMAL]" in the XML metacity themes.

This page may be useful, but I don't fully understand it.

Commenting out GtkViewport, GtkTreeView and GtkTreeView:selected in the aforementioned softwarecentre.css seem to make the necessary changes: but the front page still looks terrible thanks to the hardcoded background: Still looking to see where the background (stipple.png) is called from.

Interestingly in the css folder that contains softwarecentre.css there's also some css files labelled 'high contrast' and 'high contrast inverse' - it would be nice if we could find out how the software centre decides when to use these; then we could create a 'dark theme' one.

Jakey_TheSnake (clampstand) wrote :

'Stipple.png' is hardcoded in /usr/share/software-center/softwarecenter/ui/gtk3/views/

jake@janux:/usr/share/software-center$ grep -r stipple *
Binary file softwarecenter/ui/gtk3/views/catview.pyc matches
softwarecenter/ui/gtk3/views/ "ui/gtk3/art/stipple.png")
softwarecenter/ui/gtk3/views/ assets["stipple"] = ptrn
softwarecenter/ui/gtk3/views/ cr.set_source(_asset_cache["stipple"])

Kiba (kiba) wrote :

More than 4 years with this bug not being fixed, this is why i use synaptic.

Considering that ubuntu software center is the go to place when new users are installing packages, this issue should have been resolved a long time IMHO. The css file proposed by Tommy (post #13) makes the application usable again. I can't be assumed that new users all use the light theme...

Shawn Landden (0-shawn) wrote :

Guys. If you posted a small bounty on you might get a quick resolution to this bug. When the bug doesn't effect the default path that is kinda how free software works if you don't have the personal ability to fix the bug.

I am seeing this bug on my MacBook Pro and MacBook Air

Bruce Pieterse (octoquad) wrote :

I've started working on a patch for this two weeks ago and I'm hoping that I can get this finished by next week.

Currently I have a problem getting the fake ratings API to work under Ubuntu Gnome, but I have a work around in mind.

This is a separate style sheet that will only load if Adwaita is the GTK theme currently being used based off the Ubuntu Gnome palette.

Before officially linking the branch to this bug report I would like to run it through the Ubuntu Gnome Artwork team to see if they would like to tweak any colors.

Screen shots attached. Feedback is welcome.

Changed in ubuntu-gnome:
importance: Medium → High
assignee: nobody → Bruce Pieterse (octoquad)
Changed in ubuntu-gnome:
status: Confirmed → In Progress

keying a fix for this general problem to a specific theme seems like the wrong solution. The proper fix is to just honor the theme's foreground/background colors, whether it is Adwaita or some thing different.

I think the images look great.

On Thu, Jun 11, 2015 at 1:22 PM, David Biesack <email address hidden>

> keying a fix for this general problem to a specific theme seems like the
> wrong solution. The proper fix is to just honor the theme's
> foreground/background colors, whether it is Adwaita or some thing
> different.
> --
> You received this bug notification because you are subscribed to the bug
> report.
> Title:
> Software center have hardcoded colors and shows white font on white bg
> Status in Ubuntu Software Center:
> Confirmed
> Status in Ubuntu GNOME:
> In Progress
> Status in software-center package in Ubuntu:
> Confirmed
> Bug description:
> When using dark theme
> ProblemType: Bug
> DistroRelease: Ubuntu 11.10
> Package: software-center 5.0.2ubuntu0.1
> ProcVersionSignature: Ubuntu 3.0.0-13.22-generic 3.0.6
> Uname: Linux 3.0.0-13-generic i686
> ApportVersion: 1.23-0ubuntu4
> Architecture: i386
> Date: Sun Dec 4 15:28:41 2011
> InstallationMedia: Ubuntu 10.10 "Maverick Meerkat" - Release i386
> (20101007)
> PackageArchitecture: all
> ProcEnviron:
> PATH=(custom, user)
> LANG=en_US.UTF-8
> SHELL=/bin/zsh
> SourcePackage: software-center
> UpgradeStatus: Upgraded to oneiric on 2011-10-16 (48 days ago)
> To manage notifications about this bug go to:

Narcis Garcia (narcisgarcia) wrote :

Bruce's is not a fix for this bug. It's a workaround, because the bug is at "Software center" application.

Matthew Paul Thomas (mpt) wrote :

Jakey_TheSnake: "but the front page still looks terrible thanks to the hardcoded background:"

So anyone fluent with Gimp could fix that part, even if you aren't a coder: edit or redraw <> ("download file") so that it is stipple on a transparent background, rather than stipple on a hard-coded grey background.

Once we've done that, the colors won't need to be hard-coded for the sake of the stipple background, so maybe removing those CSS rules is enough to fix the bug.

Matthew Paul Thomas (mpt) wrote :

(I removed a drive-by comment from someone cursing a non-existent "ubuntu-software-center development group". If anyone wants to help fixing the bug, I suggest following the steps I wrote above.)

Omadas (bsperger) wrote :

Here is the transparent stipple.png. Let me know if you need any other images.

Omadas (bsperger) wrote :

Alerted the Ubuntu One Control Tower of the image revision with a link to this bug for review and consideration, and possible usage. Thanks Matthew.

Bruce Pieterse (octoquad) wrote :

I took some time to test out Matthews idea about the transparent stipple. I have attached some screen shots which show the stipple in different states:

1. The original
2. Transparent
3. Original with custom Adwaita CSS
4. Transparent with custom Adwaita CSS
5. Transparent with custom Adwaita CSS and 90% transparency drawn by Cairo (line 178 of Default is 50%.

When testing the transparent stipple with Adwaita, the text becomes more illegible.

USC has support to load custom css based off the gtk-theme-name, which you can see in line 55 of You can easily test the loading of the theme by opening USC and then changing it to something like highcontrast which has its on css file and this will change in real time. So if you use Numix you can provide a softwarecenter.numix.css.

From what I can see for a workaround to use GTK theme colors, simply move softwarecenter.css out the way (softwarecenter.css.bak). The code currently looks for a softwarecenter.<theme-name>.css if that does not exist, it loads up the softwarecenter.css. If that does not exist as well it uses the styling from the GTK theme.

Alternatively whip up your own CSS file for your favourite theme, or ask the author to create one for USC if you want USC to match the theme.

I hope that helps a bits. I understand that this approach is for Adwaita, but no one has provided the theme name they use when they filed or commented on this bug report. So my next question is, what theme(s) are you using?

Bruce Pieterse (octoquad) wrote :

Oh, here is the stipple recreated in GIMP if anybody wants to play around with it. Omadas, I totally missed your comment and attachment!

Changed in ubuntu-gnome:
milestone: none → wily
tags: added: vivid wiley
tags: added: wily
removed: wiley
tjk (tim-klassen) wrote :

Every once in a while I forget why I don't use Ubuntu Software Center... but then I start it and remember why... I can't read anything (white font on white background). This has been a weird situation because I run a lot of apps and NONE have this problem with the current theme that I use.

I decided to look up the bug this time... and what a long history there is for this bug! I don't know how apps like this get included with a mainstream ubuntu. It appears that a couple months you were close to a fix, but then... the progress has seem to have stalled. It makes me think that USC really isn't supported. If a "minor" bug like this can't be fixed, then how should I feel about the quality of the Ubuntu Software Center as a whole?

Narcis Garcia (narcisgarcia) wrote :

New workaround:

$ sudo apt-get update
$ sudo apt-get install lubuntu-software-center
$ sudo apt-get remove software-center

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package software-center - 13.10-0ubuntu8

software-center (13.10-0ubuntu8) wily; urgency=medium

  [ Iain Lane ]
  * 07_bzr_add_style_class_actionbar.patch:
    Add a style class for the action bar, so that we can give it some theming.

  [ Bruce Pieterse ]
  * 08_bzr_1448355-docs-fix-aptdaemon-test.patch: (LP: #1448355)
    README: Updated development package to python3-aptdaemon.test as
    python-aptdaemon.test is not available in 15.04
  * 09_bzr_899878-hardcoded-colors-dark-theme.patch: (LP: #899878)
    Added support for Adwaita Dark Theme Variant
    - Added new softwarecenter.adwaita-dark.css file
    - Added detection for adwaita and dark theme setting
    - Adjusted transparency drawing of stipple by 20%

 -- Didier Roche <email address hidden> Thu, 03 Sep 2015 09:42:53 +0200

Changed in software-center (Ubuntu):
status: Confirmed → Fix Released
Changed in ubuntu-gnome:
status: In Progress → Fix Released
Narcis Garcia (narcisgarcia) wrote :

- In Trusty repositories I just see software-center updated to version 13.10-0ubuntu4.1
- In Vivid repositories I just see software-center updated to version 13.10-0ubuntu6.1

How is the process/time to be this released fix available for normal updates?

Bruce Pieterse (octoquad) wrote :


This was only fixed for Wily (15.10). I don't think this fix will be backported to trusty or vivid unfortunately.

Narcis Garcia (narcisgarcia) wrote :

Really unfortunate if fix is not backported to Ubuntu Trusty (14.04 LTS).
With this scenario, this "obsolete" bug will be present whole LTS lifecycle (up to 2019)

HEXcube (hexcube) wrote :

Since Ubuntu 15.10"Wily"'s getting EOL'd in 9 months and Software Center's gonna be dropped from Ubuntu 16.04LTS, I think the most relevant place for this fix is Ubuntu 14.04LTS "Trusty Tahr". Like @narcisgarcia pointed out, Software Center on 14.04LTS shouldn't be left unfixed for 5 years until 2019!

Besides, there wasn't any major version change between trusty and wily versions of Software Center, as you can see from . So, a backport's feasible. How about we request to backport this fix through an SRU ( for Ubuntu 14.04LTS?

Bruce Pieterse (octoquad) wrote :

Narcis and HEXcube, I'll see what I can do. I don't have a time frame as yet but I'll keep you updated on the progress.

HEXcube (hexcube) wrote :

@octoquad That's great! If the fix is backported, I can do the testing and verification 😊

HEXcube (hexcube) wrote :

@octoquad , I downloaded the modified files from your branch and used them to directly replace the corresponding files in `/usr/share/software-center/*` . I wouldn't normally replace files like this, but Ubuntu 14.04LTS and 15.10 use the same version of Software Center except for some patches (See ).

Then for testing dark theme, I copied `/usr/share/software-center/ui/gtk3/css/softwarecenter.adwaita-dark.css` and renamed the copy to `softwarecenter.numix bluo-dark.css`, coz Numix Bluo (a custom mod of Numix theme) is my current GTK theme. Then I opened Software Center and it loaded the dark theme! 😊 But wait, the color was a bit grey coz of the old `stipple.png`. So, I tried @bsperger 's transparent stipple from but for some reason it crashes Software Center. 😞 So, I tried the one from and exported it to PNG using GIMP. Software Center loads it fine, but results were similar to the 4th case (transparent stipple with custom css) from . So, like in the 5th case, I edited `/usr/share/software-center/softwarecenter/ui/gtk3/views/` and reduced alpha to 0.1 and then it looked well!

So on the whole, the patch looks compatible with 14.04LTS's Software Center and so I request a backport through an SRU update.

Bruce Pieterse (octoquad) wrote :

HEXCube, thanks for testing. The only thing I was slightly concerned about is the detection of the gnome dark theme in softwarecenter/ui/gtk3/ You can also use the original stipple and reduce the opacity to 0.3 or lower( to go darker). I dropped the transparent stipple as it was harder to get the right level of darkness without affecting the normal Ubuntu themes. In your case though, it's fine.

To post a comment you must log in.